'''
Created on Mar 31, 2014

@author:   Andre Dozier

@summary:  This module calculates the price curves for the C-BT system   
           analysis given some benchmark data from literature for an annual 
           timestep
'''
import os
import numpy as np
from definitions import ScenarioType, PiecewiseLinearDemand, PiecewiseProblem
 
# global variables
output_directory = '.' + os.sep + 'figures' + os.sep

# user information
users = np.array(['Agriculture', 'Municipal'])
userabbrev = np.array(['Ag', 'Muni'])
timesteps = ['Annual']
max_demand = np.array([350000.,115000.])
stepsize = np.array([10000., 5000.])

# linear demand functions
muni = PiecewiseLinearDemand([750.0, 425.48],[-0.0238 / 2., -0.00367], verbose=True)
ag = PiecewiseLinearDemand([62.05],[-0.00018], verbose=True)
fxns = [ag, muni]

# problem definition
problemdef = PiecewiseProblem(users, userabbrev, fxns, timesteps, max_demand, stepsize) 

