'''
Created on Dec 3, 2013

@author: Andre Dozier
'''
import warnings


if __name__ == '__main__': 
    
    with warnings.catch_warnings():
        warnings.simplefilter("ignore")    

        # test the package and make sure that it's working properly
        import os, sys, pkgutil # glob, imp
        
        # if all succeed
        succeed = True
        
        # get the directory and files 
        thedir = os.path.dirname(os.path.realpath(__file__))
        parentdir = os.path.join(thedir, '..')
        childdir = os.path.join(thedir, 'tests')
        
        # remove this and child and parent directories
        while sys.path.count(thedir) > 0: 
            sys.path.remove(thedir)
        while sys.path.count(childdir) > 0: 
            sys.path.remove(childdir)
        while sys.path.count(parentdir) > 0: 
            sys.path.remove(parentdir) 
            
        # add each directory 
        sys.path.append(parentdir)
        sys.path.append(thedir)
        sys.path.append(childdir)
        print 'Starting tests in:'
        print '    ' + thedir + '\n\n'
    
        # loop through all files and import them to currtest
        for importer, package_name, _ in pkgutil.iter_modules([childdir]):
            full_package_name = '%s.%s' % (childdir, package_name)
#            if full_package_name not in sys.modules:
            currtest = importer.find_module(package_name).load_module(full_package_name)
    #     for thefile in thefiles: 
    #         currtest = imp.load_source('module.name', thefile)
            if not hasattr(currtest, 'run'): 
                continue
            if hasattr(currtest, 'testname'):  
                print 'Working on ' + currtest.testname
            else: 
                print 'Working on ' + os.path.basename(full_package_name)
            if not currtest.run(verbose=False):
                print '-- failed'
                print '*******************' 
                print 'Running again with verbose = True'
                if currtest.run(verbose=True): 
                    print 'Weird... It worked this time!!!'
                print '*******************'
                succeed = False
            else: 
                print '-- succeeded'      
                
        # complete and inform of results 
        if succeed: 
            print '\n\nAll tests succeeded'
        else: 
            print '\n\nSome tests failed'


