'''
Created on Mar 31, 2014

@author:   Andre Dozier

@summary:  This module calculates the price curves for the C-BT system   
           analysis given some benchmark data from literature for an annual 
           timestep
'''

import os
import numpy as np
from demand_functions import PiecewiseLinearDemand, PiecewiseLinearDemandList
 
# global variables
output_directory = '.' + os.sep + 'figures' + os.sep

# user information
users = np.array(['Agriculture', 'Municipal'])
userabbrev = np.array(['Ag', 'Muni'])
timesteps = ['Winter', 'Summer']
max_demand = np.array([[0.,115000.], [350000.,115000.]])
stepsize = np.array([[10000., 5000.], [10000., 5000.]])

# linear demand functions
muni_winter = PiecewiseLinearDemand([750.0],[-0.0238])
muni_summer = PiecewiseLinearDemand([750.0, 366.48],[-0.0238, -0.00434])
ag = PiecewiseLinearDemand([62.05],[-0.00018])
fxns = [None, muni_winter, ag, muni_summer] 

# problem definition
problemdef = PiecewiseProblem(users, userabbrev, fxns, timesteps, max_demand, stepsize) 

